diff --git a/totara/appraisal/lib.php b/totara/appraisal/lib.php
index 266e779..22ea9b7 100644
--- a/totara/appraisal/lib.php
+++ b/totara/appraisal/lib.php
@@ -207,8 +207,8 @@ class appraisal {
      */
     public function set_status($newstatus) {
         $allowedstatus = array(
-            self::STATUS_ACTIVE => array(self::STATUS_CLOSED, self::STATUS_COMPLETED),
-            self::STATUS_CLOSED => array(),
+            self::STATUS_ACTIVE => array(self::STATUS_CLOSED),
+            self::STATUS_CLOSED => array(self::STATUS_ACTIVE),
             self::STATUS_DRAFT => array(self::STATUS_ACTIVE),
             self::STATUS_COMPLETED => array()
         );
@@ -219,7 +219,7 @@ class appraisal {
             throw new appraisal_exception(get_string('error:cannotchangestatus', 'totara_appraisal', $a));
         } else {
             $this->status = $newstatus;
-            if ($newstatus == self::STATUS_COMPLETED || $newstatus == self::STATUS_CLOSED) {
+            if ($newstatus == self::STATUS_CLOSED) {
                 $this->timefinished = time();
             } else if ($newstatus == self::STATUS_ACTIVE) {
                 $this->timefinished = null;
@@ -282,7 +282,8 @@ class appraisal {
         if (is_null($time)) {
             $time = time();
         }
-        $err = array();
+        $err = array(); // Errors.
+        $war = array(); // Warnings.
 
         // Check that the current status is draft.
         if ($this->status != self::STATUS_DRAFT) {
@@ -296,7 +297,7 @@ class appraisal {
         }
 
         // Ensure each user has every required role.
-        $err += $this->validate_roles();
+        $war += $this->validate_roles();
 
         // Check that all stages are valid.
         $stages = appraisal_stage::fetch_appraisal($this->id);
@@ -310,32 +311,67 @@ class appraisal {
             $timesdue[] = $checkstage->timedue;
         }
 
-        return $err;
+        return array($err, $war);
+    }
+
+    /**
+     * Compare existing user assignments against group assignments to see if there have been changes
+     *
+     * @param $userassignments recordset    -   data from get_current_users()
+     * @param $groupassignments recordset   -   data from get_current_users()
+     * @return boolean                      -   true if there are differences
+     */
+    public function compare_assignments($userassignments, $groupassignments) {
+
+        // Expecting a recordset so we need to loop through to convert.
+        $ualist = array();
+        foreach ($userassignments as $ua) {
+            $ualist[$ua->id] = $ua->id;
+        }
+
+        // Expecting a recordset so we need to loop through to convert.
+        $galist = array();
+        foreach ($groupassignments as $ga) {
+            $galist[$ga->id] = $ga->id;
+        }
+
+        if (array_diff($ualist, $galist)) {
+            return true;
+        }
+
+        if (array_diff($galist, $ualist)) {
+            return true;
+        }
+
+        return false;
     }
 
     /**
-     * Check for problems activating an appraisal due to missing roles
+     * Check for potential problems with role assignments
+     * used on activation and updating of user assignments, and the warnings page.
      *
-     * @return $err Array Array of error strings to combine with any existing errors
+     * @param $live boolean     A flag to switch between live data and groups data.
+     * @return $war Array       Array of warning strings to combine with any existing warnings
      */
-    public function validate_roles() {
+    public function validate_roles($live = false) {
         global $DB, $CFG;
         require_once($CFG->dirroot . '/totara/hierarchy/prefix/position/lib.php');
 
         if (!defined('APPRAISAL_VALIDATION_MAX_BAD_ROLES')) {
             define('APPRAISAL_VALIDATION_MAX_BAD_ROLES', 500);
         }
-        $err = array();
+
+        $war = array(); // Warnings.
 
         $assign = new totara_assign_appraisal('appraisal', $this);
         $learnercount = $assign->get_current_users_count();
         if (!$learnercount) {
-            $err['learners'] = get_string('appraisalinvalid:learners', 'totara_appraisal');
-            return $err;
+            $war['learners'] = get_string('appraisalinvalid:learners', 'totara_appraisal');
+            return $war;
         }
 
-        // Get user info and roles for all users involved
-        // in this appraisal who have at least one role
+        // Get user info and roles for all users involved.
+        // in this appraisal who have at least one role.
         // missing.
         $usernamefields = get_all_user_name_fields(true, 'u');
         $select = "SELECT
@@ -353,8 +389,14 @@ class appraisal {
                 ON (pa.managerid = pa2.userid AND pa2.type = ?)";
         $params = array(POSITION_TYPE_PRIMARY, POSITION_TYPE_PRIMARY);
 
-        // Get SQL to limit to only users involved in this appraisal.
-        list($joinsql, $joinparams) = $assign->get_users_from_groups_sql('u', 'id');
+        if ($live) {
+            // User the appraisals user assignments instead of group assignments.
+            $joinsql = " JOIN ( SELECT aua.userid AS userid FROM {appraisal_user_assignment} aua WHERE aua.appraisalid = ? AND aua.status = ? ) liveusers ON liveusers.userid = u.id ";
+            $joinparams = array($this->id, self::STATUS_ACTIVE);
+        } else {
+            // Get SQL to limit to only users involved in this appraisal.
+            list($joinsql, $joinparams) = $assign->get_users_from_groups_sql('u', 'id');
+        }
 
         $params = array_merge($params, $joinparams);
 
@@ -374,7 +416,7 @@ class appraisal {
 
         // No roles to check, no need to run query.
         if (empty($rolestocheck)) {
-            return $err;
+            return $war;
         }
         $wheresql = ' WHERE ' . implode(' OR ', $rolestocheck);
 
@@ -382,7 +424,7 @@ class appraisal {
         $missingroles = $DB->get_records_sql($select.$from.$joinsql.$wheresql, $params, 0, APPRAISAL_VALIDATION_MAX_BAD_ROLES);
         $nummissing = $DB->count_records_sql($count.$from.$joinsql.$wheresql, $params);
 
-        // Add an error for each missing role.
+        // Add a warning for each missing role.
         $rolefieldmap = array(
             self::ROLE_LEARNER => 'id',
             self::ROLE_MANAGER => 'managerid',
@@ -396,20 +438,270 @@ class appraisal {
                     $a = new stdClass();
                     $a->user = fullname($missingrole);
                     $a->role = get_string($allroles[$role], 'totara_appraisal');
-                    $err['missingrole' . $allroles[$role] . $missingrole->id] =
+                    $war['missingrole' . $allroles[$role] . $missingrole->id] =
                         get_string('appraisalinvalid:missingrole',
                         'totara_appraisal', $a);
                 }
             }
         }
 
-        // If there were more records to show, add one more error listing how many have been truncated.
+        // If there were more records to show, add one more warning listing how many have been truncated.
         if ($nummissing > APPRAISAL_VALIDATION_MAX_BAD_ROLES) {
-            $err['missingrolesmore'] = get_string('xmoremissingroles', 'totara_appraisal',
+            $war['missingrolesmore'] = get_string('xmoremissingroles', 'totara_appraisal',
                 ($nummissing - APPRAISAL_VALIDATION_MAX_BAD_ROLES));
         }
 
-        return $err;
+        return $war;
+    }
+
+
+    /**
+     * Update user and role assignments for a live appraisal.
+     * Used via the cron and appraisals learners tab
+     */
+    public function check_assignment_changes() {
+        global $CFG, $DB;
+
+        $assign = new totara_assign_appraisal('appraisal', $this);
+
+        // Create user assignments and role assignments for new users.
+        $added = $assign->get_unstored_users();
+        if ($added->valid()) {
+            $assign->store_user_assignments($added);
+
+            // Set active stage for all new users.
+            $stages = appraisal_stage::get_stages($this->id);
+            $DB->set_field('appraisal_user_assignment', 'activestageid', reset($stages)->id, array('appraisalid' => $this->id, 'activestageid' => null));
+        }
+
+        // Find old user assignments that need to be reactivated.
+        list($assignjoinsql, $assignparams, $assignalias) = $assign->get_users_from_assignments_sql('u', 'id');
+        list($groupjoinsql, $groupparams, $groupalias) = $assign->get_users_from_groups_sql('u', 'id');
+
+        $sql = "UPDATE {appraisal_user_assignment}
+                   SET status = ?
+                 WHERE status = ?
+                   AND appraisalid = ?
+                   AND userid IN (
+                       SELECT u.id
+                         FROM {user} u
+                       " . $groupjoinsql . "
+                   )";
+        $params = array_merge(array(self::STATUS_ACTIVE, self::STATUS_CLOSED, $this->id), $groupparams);
+        $DB->execute($sql, $params);
+
+        // Find removed learners.
+        $removed = $assign->get_removed_users();
+        // Close user assignment for each user.
+        if ($removed->valid()) {
+            foreach ($removed as $user) {
+                $userassignment = new appraisal_user_assignment($user->userassignmentid);
+
+                $userassignment->close();
+            }
+        }
+
+        // Find role changes for appraisal assignments.
+        $changed = $this->get_changedrole_users();
+        $transaction = $DB->start_delegated_transaction();
+
+        // Check for existing data.
+        foreach ($changed as $rolechange) {
+
+            // Add record to new 'role changes' table.
+            $changerecord = new stdClass();
+            $changerecord->userassignmentid = $rolechange->userassignment;
+            $changerecord->originaluserid = $rolechange->olduserid;
+            $changerecord->newuserid = $rolechange->newuserid;
+            $changerecord->role = $rolechange->role;
+            $changerecord->timecreated = time();
+
+            $DB->insert_record('appraisal_role_changes', $changerecord);
+
+            // Switch user in role assignment.
+            $roleupdate = new stdClass();
+            $roleupdate->id = $rolechange->roleassignment;
+            $roleupdate->userid = is_null($rolechange->newuserid) ? 0 : $rolechange->newuserid;
+
+            $DB->update_record('appraisal_role_assignment', $roleupdate);
+        }
+
+        $transaction->allow_commit();
+    }
+
+    /**
+     * Check for user assignments with missing roles.
+     *
+     * @return Array
+     */
+    public function get_missingrole_users() {
+        global $DB;
+
+        $assign = new totara_assign_appraisal('appraisal', $this);
+
+        $select = "SELECT
+            ara.id,
+            u.userid,
+            ara.appraisalrole,
+            pa.managerid,
+            pa2.managerid AS teamleadid,
+            pa.appraiserid";
+
+        $from = " FROM {appraisal_user_assignment} u
+            LEFT JOIN (SELECT * FROM {pos_assignment} WHERE type = 1) pa
+                ON u.userid = pa.userid
+            LEFT JOIN (SELECT * FROM {pos_assignment} WHERE type = 1) pa2
+                ON pa.managerid = pa2.userid
+            JOIN {appraisal_role_assignment} ara
+              ON u.id = ara.appraisaluserassignmentid ";
+
+        // Get SQL to limit to only users involved in this appraisal.
+        list($joinsql, $params) = $assign->get_users_from_assignments_sql('u', 'id');
+
+        // Only get rows that are missing data if we require that role.
+        $allroles = $this->get_roles();
+        $rolesinvolved = $this->get_roles_involved();
+        $rolestocheck = array();
+        foreach ($rolesinvolved as $roleinvolved) {
+            if ($roleinvolved == self::ROLE_MANAGER) {
+                $rolestocheck[] = 'pa.managerid IS NULL';
+            } else if ($roleinvolved == self::ROLE_TEAM_LEAD) {
+                $rolestocheck[] = 'pa2.managerid IS NULL';
+            } else if ($roleinvolved == self::ROLE_APPRAISER) {
+                $rolestocheck[] = 'pa.appraiserid IS NULL';
+            }
+        }
+
+        // No roles to check, no need to run query.
+        if (empty($rolestocheck)) {
+            return array();
+        }
+        $wheresql = 'WHERE u.appraisalid = ? AND ( ' . implode(' OR ', $rolestocheck) . ' )';
+        $params = array($this->id);
+
+        // Limit retrieved records but also count to see the total.
+        $missingroles = $DB->get_records_sql($select.$from.$wheresql, $params);
+
+        // Find each role that has changed.
+        $rolefieldmap = array(
+            self::ROLE_LEARNER => 'userid',
+            self::ROLE_MANAGER => 'managerid',
+            self::ROLE_TEAM_LEAD => 'teamleadid',
+            self::ROLE_APPRAISER => 'appraiserid'
+        );
+
+        $userassmissingroles = array();
+
+        foreach ($missingroles as $missingrole) {
+            $appraisalrole = array();
+            foreach ($rolesinvolved as $role) {
+                $field = $rolefieldmap[$role];
+
+                if (empty($missingrole->$field)) {
+                    $appraisalrole[] = $role;
+                }
+            }
+
+            $userassmissingroles[$missingrole->userid] = $appraisalrole;
+        }
+
+        return $userassmissingroles;
+    }
+
+
+    /**
+     * Get role changes for user assignments for the current appraisal
+     *
+     * @return Array
+     */
+    public function get_changedrole_users() {
+        global $DB;
+
+        $select = "SELECT
+            ara.id,
+            u.userid,
+            u.id as userassignmentid,
+            ara.userid as roleuserid,
+            ara.appraisalrole";
+
+        $from = " FROM {appraisal_user_assignment} u
+            LEFT JOIN {appraisal_role_assignment} ara
+                ON u.id = ara.appraisaluserassignmentid";
+
+        $rolesinvolved = $this->get_roles_involved();
+
+        $posjoin = false;
+        $posjoin2 = false;
+
+        foreach ($rolesinvolved as $roleinvolved) {
+            if ($roleinvolved == self::ROLE_MANAGER) {
+                $select .= ", CASE WHEN pa.managerid IS NULL THEN 0 ELSE pa.managerid END AS managerid";
+                $posjoin = true;
+            } else if ($roleinvolved == self::ROLE_TEAM_LEAD) {
+                $select .= ", CASE WHEN pa2.managerid IS NULL THEN 0 ELSE pa2.managerid END AS teamleader";
+                $posjoin2 = true;
+            } else if ($roleinvolved == self::ROLE_APPRAISER) {
+                $select .= ", CASE WHEN pa.appraiserid IS NULL THEN 0 ELSE pa.appraiserid END AS appraiserid";
+                $posjoin = true;
+            }
+        }
+
+        if ($posjoin) {
+            $from .= " JOIN {pos_assignment} pa
+                ON pa.userid = u.userid AND pa.type = 1 ";
+        }
+
+        if ($posjoin2) {
+            $from .= " LEFT JOIN {pos_assignment} pa2
+                ON pa2.userid = pa.managerid AND pa2.type = 1 ";
+        }
+
+        $wheresql = " WHERE u.status = 1 AND u.appraisalid = ?";
+
+        $currentroleassignments = $DB->get_records_sql($select.$from.$wheresql, array($this->id));
+
+        $changedroles = array();
+        foreach ($currentroleassignments as $roleassignment) {
+            if ($roleassignment->appraisalrole == self::ROLE_MANAGER) {
+                if ($roleassignment->roleuserid != $roleassignment->managerid) {
+                    $change = new stdClass();
+                    $change->userassignment  = $roleassignment->userassignmentid;
+                    $change->role = $roleassignment->appraisalrole;
+                    $change->roleassignment = $roleassignment->id;
+                    $change->olduserid = $roleassignment->roleuserid;
+                    $change->newuserid = $roleassignment->managerid;
+                    $change->timecreated = time();
+
+                    $changedroles[] = $change;
+                }
+            } else if ($roleassignment->appraisalrole == self::ROLE_TEAM_LEAD) {
+                if ($roleassignment->roleuserid != $roleassignment->teamleader) {
+                    $change = new stdClass();
+                    $change->userassignment  = $roleassignment->userassignmentid;
+                    $change->role = $roleassignment->appraisalrole;
+                    $change->roleassignment = $roleassignment->id;
+                    $change->olduserid = $roleassignment->roleuserid;
+                    $change->newuserid = $roleassignment->teamleader;
+                    $change->timecreated = time();
+
+                    $changedroles[] = $change;
+                }
+            } else if ($roleassignment->appraisalrole == self::ROLE_APPRAISER) {
+                if ($roleassignment->roleuserid != $roleassignment->appraiserid) {
+                    $change = new stdClass();
+                    $change->userassignment  = $roleassignment->userassignmentid;
+                    $change->role = $roleassignment->appraisalrole;
+                    $change->roleassignment = $roleassignment->id;
+                    $change->olduserid = $roleassignment->roleuserid;
+                    $change->newuserid = $roleassignment->appraiserid;
+                    $change->timecreated = time();
+
+                    $changedroles[] = $change;
+                }
+            }
+        }
+
+        return $changedroles;
     }
 
     /**
@@ -432,8 +724,8 @@ class appraisal {
             $alert->fullmessage = $formdata->alertbody;
             $alert->fullmessagehtml = $alert->fullmessage;
 
-            $learners = $DB->get_records('appraisal_user_assignment',
-                    array('appraisalid' => $formdata->id, 'timecompleted' => null), null, 'userid AS id');
+            $params = array('appraisalid' => $formdata->id, 'timecompleted' => null, 'status' => self::STATUS_ACTIVE);
+            $learners = $DB->get_records('appraisal_user_assignment', $params, null, 'userid AS id');
 
             foreach ($learners as $learner) {
                 $alert->userto = $learner;
@@ -453,10 +745,12 @@ class appraisal {
                         ON aua.userid = usr.id
                      WHERE aua.timecompleted IS NULL
                        AND aua.appraisalid = ?
+                       AND aua.status = ?
                        AND ara.appraisalrole != ?
+                       AND ara.userid <> 0
                      GROUP BY ara.userid';
 
-            $roleusers = $DB->get_records_sql($sql, array($formdata->id, self::ROLE_LEARNER));
+            $roleusers = $DB->get_records_sql($sql, array($formdata->id, self::STATUS_ACTIVE, self::ROLE_LEARNER));
 
             foreach ($roleusers as $roleuser) {
                 $formdata->staff = $roleuser->staff;
@@ -467,7 +761,13 @@ class appraisal {
             }
         }
 
+        // Mark the status as closed for the appraisal.
         $this->set_status(self::STATUS_CLOSED);
+
+        // Mark the status as closed for all user assignments.
+        $sql = "UPDATE {appraisal_user_assignment} SET status = ? WHERE status = ? AND appraisalid = ?";
+        $DB->execute($sql, array(self::STATUS_CLOSED, self::STATUS_ACTIVE, $this->id));
+
     }
 
 
@@ -569,6 +869,7 @@ class appraisal {
         if (($this->status == self::STATUS_CLOSED) || ($this->status == self::STATUS_COMPLETED)) {
             return true;
         }
+
         if (isset($assignment)) {
             if ($assignment instanceof appraisal_role_assignment) {
                 $userassignment = $assignment->get_user_assignment();
@@ -578,13 +879,18 @@ class appraisal {
                 throw new appraisal_exception('Wrong assignment class');
             }
         }
+
+        // Is appraisal locked for the user?
+        if (isset($userassignment) && $userassignment->is_closed()) {
+            return true;
+        }
+
         return isset($userassignment) && $userassignment->timecompleted > 0;
     }
 
 
     /**
      * Mark the appraisal as complete for the given user.
-     * Then check if all users are complete and if so then mark this appraisal as complete.
      *
      * @param int $subjectid
      */
@@ -595,20 +901,9 @@ class appraisal {
         $DB->set_field('appraisal_user_assignment', 'timecompleted', time(),
                 array('userid' => $subjectid, 'appraisalid' => $this->id));
 
-        // Check if all users are complete.
-        $unfinished = $DB->count_records('appraisal_user_assignment',
-                array('appraisalid' => $this->id, 'timecompleted' => null));
-        if (!$unfinished) {
-            // Mark this appraisal as complete.
-            $this->complete();
-        }
-    }
-
-    /**
-     * Mark this appraisal as complete.
-     */
-    public function complete() {
-        $this->set_status(self::STATUS_COMPLETED);
+        // Mark the user as complete for this appraisal.
+        $DB->set_field('appraisal_user_assignment', 'status', self::STATUS_COMPLETED,
+                array('userid' => $subjectid, 'appraisalid' => $this->id));
     }
 
     /**
@@ -656,11 +951,13 @@ class appraisal {
     public function count_incomplete_userassignments() {
         global $DB;
 
-        return $DB->count_records('appraisal_user_assignment', array('appraisalid' => $this->id, 'timecompleted' => null));
+        $params = array('appraisalid' => $this->id, 'timecompleted' => null, 'status' => self::STATUS_ACTIVE);
+        return $DB->count_records('appraisal_user_assignment', $params);
     }
 
     /**
      * Return array of roles involved in current appraisal
+     * array(appraisalrole => appraisalrole)
      *
      * @param int $rights count only roles that have certain rights
      * @return array of appraisalrole
@@ -694,6 +991,33 @@ class appraisal {
         return array_keys($out);
     }
 
+    /**
+     * Return array of roles involved in current appraisal linking to assigned users.
+     * array(appraisalrole => userid)
+     *
+     * @param subjectid the userid in the userassignment
+     * @return array
+     */
+    public function get_user_roles_involved($rights, $subjectid) {
+        global $DB;
+
+        $roles = $this->get_roles_involved($rights);
+        if (empty($roles)) {
+            return array();
+        }
+
+        list($insql, $inparam) = $DB->get_in_or_equal(array_keys($roles));
+        $missingsql = "SELECT ara.appraisalrole, ara.userid
+                         FROM {appraisal_role_assignment} ara
+                         JOIN {appraisal_user_assignment} aua
+                           ON ara.appraisaluserassignmentid = aua.id
+                        WHERE aua.userid = ?
+                          AND aua.appraisalid = ?
+                          AND appraisalrole {$insql}";
+        $missingparams = array_merge(array($subjectid, $this->appraisalid), $inparam);
+        return $DB->get_records_sql($missingsql, $missingparams);
+    }
+
 
     /**
      * Create answers table
@@ -753,7 +1077,7 @@ class appraisal {
 
 
     /**
-     * Save snapshot
+     * Save snapshot to the file system
      *
      * @param string $filepath snapshot /path/filename.pdf
      * @param int $roleassignmentid snapshot role assignment id
@@ -857,23 +1181,52 @@ class appraisal {
         $this->id = null;
     }
 
-
     /**
-     * Check if appraisal is in draft state
+     * Get the status of the appraisal.
      *
-     * @param mixed $appraisal appraisal.id or instance of appraisal
-     * @return bool
+     * @param mixed $appraisal  - appraisal.id or instance of appraisal
+     * @return int              - self::STATUS_DRAFT etc
      */
-    public static function is_draft($appraisal) {
+    public static function get_status($appraisal) {
         if (is_numeric($appraisal)) {
             $appraisal = new appraisal($appraisal);
         }
         if (!($appraisal instanceof appraisal)) {
             throw new appraisal_exception('Appraisal object not found', 2);
         }
-        return ($appraisal->status == self::STATUS_DRAFT);
+
+        return $appraisal->status;
     }
 
+    /**
+     * Check if appraisal is in draft state
+     *
+     * @param mixed $appraisal  - appraisal.id or instance of appraisal
+     * @return bool
+     */
+    public static function is_draft($appraisal) {
+        return (self::get_status($appraisal) == self::STATUS_DRAFT);
+    }
+
+    /**
+     * Check if appraisal is in an active state
+     *
+     * @param mixed $appraisal  - appraisal.id or instance of appraisal
+     * @return bool
+     */
+    public static function is_active($appraisal) {
+        return (self::get_status($appraisal) == self::STATUS_ACTIVE);
+    }
+
+    /**
+     * Check if appraisal has been closed.
+     *
+     * @param mixed $appraisal  - appraisal.id or instance of appraisal
+     * @return bool
+     */
+    public static function is_closed($appraisal) {
+        return (self::get_status($appraisal) == self::STATUS_CLOSED);
+    }
 
     /**
      * Get all individual roles supported by system (except two: 'Administrator' is reserved, 'All' is not a role.)
@@ -891,6 +1244,27 @@ class appraisal {
     }
 
     /**
+     * Get the current position assignments for a users appraisal role assignments
+     *
+     * @param int userid The id of the user to get the current assignments for
+     * @return array(appraisal::ROLE_* => userid)
+     */
+    public static function get_live_role_assignments($userid) {
+        $manager = totara_get_manager($userid);
+        $teamleader = totara_get_teamleader($userid);
+        $appraiser = totara_get_appraiser($userid);
+
+        $roles = array(
+            self::ROLE_LEARNER => $userid,
+            self::ROLE_MANAGER => $manager ? $manager->id : 0,
+            self::ROLE_TEAM_LEAD => $teamleader ? $teamleader->id : 0,
+            self::ROLE_APPRAISER => $appraiser ? $appraiser->id : 0,
+        );
+
+        return $roles;
+    }
+
+    /**
      * Get status name
      *
      * @param int $status
@@ -1147,7 +1521,7 @@ class appraisal {
         global $DB, $USER;
         $params = array($USER->id, $role);
         $sql = 'SELECT ' . $DB->sql_concat(sql_cast2char('a.id'), "'_'", sql_cast2char('aua.userid')) . ' AS uniqueid,
-                       a.id, aua.userid, a.name, a.timestarted, a.status, MAX(ast.timedue) AS timedue, aua.timecompleted,
+                       a.id, aua.userid, a.name, a.timestarted, aua.status, MAX(ast.timedue) AS timedue, aua.timecompleted,
                        ara.id as roleassignmentid
                   FROM {appraisal} a
                   JOIN {appraisal_user_assignment} aua
@@ -1166,8 +1540,8 @@ class appraisal {
             $sql .= ' AND a.status ' . $sqlstatus;
             $params = array_merge($params, $paramstatus);
         }
-        $sql .= ' GROUP BY a.id, aua.userid, a.name, a.timestarted, a.status, aua.timecompleted, ara.id
-                  ORDER BY CASE WHEN aua.timecompleted IS NULL AND a.status = ? THEN 0 ELSE 1 END, a.timestarted DESC';
+        $sql .= ' GROUP BY a.id, aua.userid, a.name, a.timestarted, aua.status, aua.timecompleted, ara.id
+                  ORDER BY CASE WHEN aua.timecompleted IS NULL AND aua.status = ? THEN 0 ELSE 1 END, a.timestarted DESC';
         $params[] = self::STATUS_ACTIVE;
         $appraisals = $DB->get_records_sql($sql, $params);
         return $appraisals;
@@ -1192,6 +1566,76 @@ class appraisal {
 
         return $appraisals;
     }
+
+    /**
+     * Deletes all user_assignments and associated data for a given user.
+     *
+     * @param int $userid   - The id of the user to run this for.
+     */
+    public static function delete_learner_assignments($userid) {
+        global $DB;
+
+        $context = context_system::instance();
+        $fs = get_file_storage();
+        $transaction = $DB->start_delegated_transaction();
+
+        $userassignments = $DB->get_records('appraisal_user_assignment', array('userid' => $userid));
+        foreach ($userassignments as $userassignment) {
+            $appraisalid = $userassignment->appraisalid;
+            $userassignmentid = $userassignment->id;
+            // Get all role assignments for this userassignment.
+            $roleassignments = $DB->get_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $userassignmentid));
+
+            foreach ($roleassignments as $roleassignment) {
+                $roleassignmentid = $roleassignment->id;
+                $DB->delete_records('appraisal_scale_data', array('appraisalroleassignmentid' => $roleassignmentid));
+                $DB->delete_records('appraisal_quest_data_' . $appraisalid, array('appraisalroleassignmentid' => $roleassignmentid));
+                $DB->delete_records('appraisal_stage_data', array('appraisalroleassignmentid' => $roleassignmentid));
+                $fs->delete_area_files($context->id, 'totara_appraisal', 'snapshot_', $appraisalid, $roleassignmentid);
+            }
+
+            $DB->delete_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $userassignmentid));
+            $DB->delete_records('appraisal_role_changes', array('userassignmentid' => $userassignmentid));
+        }
+        $DB->delete_records('appraisal_user_assignment', array('userid' => $userid));
+
+        $transaction->allow_commit();
+    }
+
+    /**
+     * Unassign all role_assignments for a given user, but retain associated data.
+     *
+     * @param int $userid   - The id of the user to run this for.
+     */
+    public static function unassign_user_roles($userid) {
+        global $DB;
+
+        $transaction = $DB->start_delegated_transaction();
+
+        // Flag all data associated with other users assignments as deleted but keep the data.
+        $roles = $DB->get_records('appraisal_role_assignment', array('userid' => $userid));
+
+        // Create role changed records for all the roles.
+        $todb = new stdClass();
+        $todb->originaluserid = $userid;
+        $todb->newuserid = 0; // Deleted so there is no new user.
+        $todb->timecreated = time();
+
+        foreach ($roles as $role) {
+            $todb->role = $role->appraisalrole;
+            $todb->userassignmentid = $role->appraisaluserassignmentid;
+
+            $DB->insert_record('appraisal_role_changes', $todb);
+        }
+
+        // Unassign all the users role assignments.
+        $sql = "UPDATE {appraisal_role_assignment} SET userid = 0 WHERE userid = ?";
+        $DB->execute($sql, array($userid));
+
+        $transaction->allow_commit();
+    }
+
+
     /**
      * Get array of appraisals with their start dates and number of learners
      *
